Subject: bug#53339: [version-1.4.0] Package with texlive-updmap.cfg and texlive-amsfonts failing to find Euler

From: Ricardo Wurmus <[email-masked]>
Date: Sun, 23 Jan 2022 18:16:25 +0100

Ricardo Wurmus <[email-masked]> writes:

> Ricardo Wurmus <[email-masked]> writes:
>
>> [email-masked] writes:
>>
>>> Attached patch on top of version-1.4.0 attempts to typset PDF docs for the
>>> metamath package. However, the below error results, which seems to indicate
>>> that the Euler fonts are not found, despite texlive-amsfonts existing in the
>>> texlive-updmap.cfg input.
>>>
>>>     (/gnu/store/s952x1vkbbcprklzlzimn3m2dn53mjx9-texlive-amsfonts-59745/share/texmf-dist/tex/latex/amsfonts/ueuf.fd)
>>>     kpathsea: Running mktextfm eufm10
>>>     mkdir: cannot create directory ?././homeless-shelter?: Permission denied
>>>     mktextfm: mktexdir /homeless-shelter/.texlive2021/texmf-var/fonts/tfm/ams/euler failed.
>>>     kpathsea: Appending font creation commands to missfont.log.
>>>     
>>>     ! Font U/euf/m/n/10=eufm10 at 10.0pt not loadable: Metric (TFM) file not found.
>>>     <to be read again>
>>
>> This is a problem with the texlive-amsfonts package.  The tlpdb says
>> that it should provide eufm10.tfm, but it doesn’t.
>
> It now does.
>
> Commit 374464a3bbd38f43784af0cdf54ddceed93e41bd adds a new
> texlive-amsfonts/fixed and adds it to the replacement field of
> texlive-amsfonts, so it should be grafted.
>
>> We can avoid these problems by checking that all texlive packages
>> produce all the outputs that the tlpdb specifies.  The texlive importer
>> already works with the tlpdb; we’d just need some sort of automatic
>> test.  We could do this as part of an optional build phase.
>
> Commit 5ecb4acdcb95478c6efe63bf9caa4db6bda82aba implements the most
> basic check.  We can’t use it during the build, because tlpdb currently
> needs modules that aren’t available on the build side (e.g. those to
> build texlive-bin and look up a file it provides), but it can be used in
> a REPL:
>
>     ,use (guix import texlive)
>     (files-differ? "/gnu/store/aiknpz049bqbr73s58yaqk3ln7hq8n4x-texlive-amsfonts-fixed-59745/share/" "amsfonts")
>
> This should return the empty list.  As should this, which lists files
> that should not have been installed according to the tlpdb:
>
>     (files-differ? "/gnu/store/aiknpz049bqbr73s58yaqk3ln7hq8n4x-texlive-amsfonts-fixed-59745/share/" "amsfonts" #:direction 'extra)
>
> The fixed package installs exactly the files it is supposed to and
> nothing more.

I just applied your patch and then tried to reproduce the problem.  I
can reproduce the problem.  I then explicitly asked for
texlive-amsfonts/fixed instead of texlive-amsfonts and I got past the
failure to find eufm10.

It’s not surprising, because grafts happen *after* the build, but it did
confuse me for a bit.

The new error looks a lot like bug 40558 which I had just closed:

--8<---------------cut here---------------start------------->8---
starting phase `build-doc'
This is pdfTeX, Version 3.141592653-2.6-1.40.22 (TeX Live 2021/GNU Guix) (preloaded format=pdflatex)
 restricted \write18 enabled.
entering extended mode
(./metamath.tex
LaTeX2e <2020-10-01> patch level 4
L3 programming layer <2021-02-18>

LaTeX Warning: Writing file `./realref.sty'.

LaTeX Warning: Writing file `./metamath.bib'.

(/gnu/store/587a5yig52dyj2bfdg44dqcyqmdv0qqp-texlive-latex-base-59745/share/texmf-dist/tex/latex/base/book.cls
Document Class: book 2020/04/10 v1.4m Standard LaTeX document class
(/gnu/store/587a5yig52dyj2bfdg44dqcyqmdv0qqp-texlive-latex-base-59745/share/texmf-dist/tex/latex/base/leqno.clo) (/gnu/store/587a5yig52dyj2bfdg44dqcyqmdv0qqp-texlive-latex-base-59745/share/texmf-dist/tex/latex/base/bk10.clo)) (/gnu/store/rvpgbbds8lk81yzx6775j6ch2xdwvv52-texlive-hyperref-59745/share/texmf-dist/tex/latex/hyperref/hyperref.sty (/gnu/store/z3l6hyyrjha51phkfcd47pmd0qfd3dk0-texlive-generic-ltxcmds-59745/share/texmf-dist/tex/generic/ltxcmds/ltxcmds.sty) (/gnu/store/9bdsk0lyzci4mh2zjsd2xhr46xjnpbwr-texlive-generic-iftex-59745/share/texmf-dist/tex/generic/iftex/iftex.sty) (/gnu/store/sj5mmzvpj1rvf7qhmj14lqm8s55lhafc-texlive-latex-pdftexcmds-59745/share/texmf-dist/tex/generic/pdftexcmds/pdftexcmds.sty (/gnu/store/8m9dsi7b7g0zm79xfxl92hyzn1frs9a2-texlive-generic-infwarerr-59745/share/texmf-dist/tex/generic/infwarerr/infwarerr.sty)) (/gnu/store/7amifddw49zp8h212nn8ks9jkw75sf4k-texlive-latex-graphics-59745/share/texmf-dist/tex/latex/graphics/keyval.sty)
(/gnu/store/65jpn1a6ypq5wsdnvmjzw1yw283ibqy9-texlive-generic-kvsetkeys-59745/share/texmf-dist/tex/generic/kvsetkeys/kvsetkeys.sty) (/gnu/store/scks7081fji2a504l8bgcfxmqss391xj-texlive-generic-kvdefinekeys-59745/share/texmf-dist/tex/generic/kvdefinekeys/kvdefinekeys.sty) (/gnu/store/3ghkimjblf7cpgnrjjj84r2n7jwcq4wd-texlive-generic-pdfescape-59745/share/texmf-dist/tex/generic/pdfescape/pdfescape.sty) (/gnu/store/nl3vss7x4q0kxyx7hn5x955ixcsgxqy4-texlive-latex-hycolor-59745/share/texmf-dist/tex/latex/hycolor/hycolor.sty) (/gnu/store/mwkfbyky333q7wwirzbhkp6n7qcrq7ns-texlive-latex-letltxmacro-59745/share/texmf-dist/tex/latex/letltxmacro/letltxmacro.sty) (/gnu/store/gv2parvnl34qwqkvq3rjb5i910kvgfi8-texlive-latex-auxhook-59745/share/texmf-dist/tex/latex/auxhook/auxhook.sty) (/gnu/store/57an07pvwb6g4n06i7c0v9m3agd4w73q-texlive-latex-kvoptions-59745/share/texmf-dist/tex/latex/kvoptions/kvoptions.sty)
(/gnu/store/rvpgbbds8lk81yzx6775j6ch2xdwvv52-texlive-hyperref-59745/share/texmf-dist/tex/latex/hyperref/pd1enc.def) (/gnu/store/rvpgbbds8lk81yzx6775j6ch2xdwvv52-texlive-hyperref-59745/share/texmf-dist/tex/latex/hyperref/hyperref-langpatches.def) (/gnu/store/d9y4xwdybmc4lww1m5rfclg6wnjq2m5s-texlive-generic-intcalc-59745/share/texmf-dist/tex/generic/intcalc/intcalc.sty) (/gnu/store/9fnwbv8rh4xam8fd7iq5ixga0kf59m1y-texlive-generic-etexcmds-59745/share/texmf-dist/tex/generic/etexcmds/etexcmds.sty) (/gnu/store/rvpgbbds8lk81yzx6775j6ch2xdwvv52-texlive-hyperref-59745/share/texmf-dist/tex/latex/hyperref/puenc.def) (/gnu/store/mxwk2779z4c9rdpfw336llfjwvq8b1m8-texlive-url-59745/share/texmf-dist/tex/latex/url/url.sty) (/gnu/store/kv80m72v0a370946z23f3mqb9qi09kxf-texlive-generic-bitset-59745/share/texmf-dist/tex/generic/bitset/bitset.sty (/gnu/store/1sq5ckqm8pfk992vsf8vbknnr2jvzdpj-texlive-generic-bigintcalc-59745/share/texmf-dist/tex/generic/bigintcalc/bigintcalc.sty))
(/gnu/store/587a5yig52dyj2bfdg44dqcyqmdv0qqp-texlive-latex-base-59745/share/texmf-dist/tex/latex/base/atbegshi-ltx.sty)) (/gnu/store/rvpgbbds8lk81yzx6775j6ch2xdwvv52-texlive-hyperref-59745/share/texmf-dist/tex/latex/hyperref/hpdftex.def (/gnu/store/587a5yig52dyj2bfdg44dqcyqmdv0qqp-texlive-latex-base-59745/share/texmf-dist/tex/latex/base/atveryend-ltx.sty) (/gnu/store/nbb28djqw81mh34x2g1ff5sxk7wrpcdw-texlive-latex-rerunfilecheck-59745/share/texmf-dist/tex/latex/rerunfilecheck/rerunfilecheck.sty (/gnu/store/bsqw8xzx6s6727sq75z0ay46awpg7qbv-texlive-generic-uniquecounter-59745/share/texmf-dist/tex/generic/uniquecounter/uniquecounter.sty))) (/gnu/store/1z0lv49q68hmr239gyhkl0fhii9w2k29-texlive-latex-needspace-59745/share/texmf-dist/tex/latex/needspace/needspace.sty) (/gnu/store/xj2g5msy7iaz3a8kbpd2cwcbjbd6248b-texlive-breqn-59745/share/texmf-dist/tex/latex/breqn/breqn.sty (/gnu/store/yfw2ldhvy8ppxjcaff5cjw990dxqjzpf-texlive-latex-l3kernel-59745/share/texmf-dist/tex/latex/l3kernel/expl3.sty
(/gnu/store/c5nji3vqx4y317kcicr3lqijvphvgv5v-texlive-latex-l3backend-59745/share/texmf-dist/tex/latex/l3backend/l3backend-pdftex.def)) (/gnu/store/znfkb5mi7zxvyrcxbv2mbmq7l9v4327l-texlive-latex-amsmath-59745/share/texmf-dist/tex/latex/amsmath/amsmath.sty
For additional information on amsmath, use the `?' option.
(/gnu/store/znfkb5mi7zxvyrcxbv2mbmq7l9v4327l-texlive-latex-amsmath-59745/share/texmf-dist/tex/latex/amsmath/amstext.sty (/gnu/store/znfkb5mi7zxvyrcxbv2mbmq7l9v4327l-texlive-latex-amsmath-59745/share/texmf-dist/tex/latex/amsmath/amsgen.sty)) (/gnu/store/znfkb5mi7zxvyrcxbv2mbmq7l9v4327l-texlive-latex-amsmath-59745/share/texmf-dist/tex/latex/amsmath/amsbsy.sty) (/gnu/store/znfkb5mi7zxvyrcxbv2mbmq7l9v4327l-texlive-latex-amsmath-59745/share/texmf-dist/tex/latex/amsmath/amsopn.sty)) (/gnu/store/7amifddw49zp8h212nn8ks9jkw75sf4k-texlive-latex-graphics-59745/share/texmf-dist/tex/latex/graphics/graphicx.sty (/gnu/store/7amifddw49zp8h212nn8ks9jkw75sf4k-texlive-latex-graphics-59745/share/texmf-dist/tex/latex/graphics/graphics.sty (/gnu/store/7amifddw49zp8h212nn8ks9jkw75sf4k-texlive-latex-graphics-59745/share/texmf-dist/tex/latex/graphics/trig.sty) (/gnu/store/zga4xvyy7h1ww3isg35l6y2yp3m2hcs0-texlive-graphics-cfg-59745/share/texmf-dist/tex/latex/graphics-cfg/graphics.cfg)
(/gnu/store/s7bg33d6knlkn7bab9756pk7g747clps-texlive-graphics-def-59745/share/texmf-dist/tex/latex/graphics-def/pdftex.def))) (/gnu/store/vywyhkvz2nr5037jfz8f10mzcszh5ldh-texlive-flexisym-59745/share/texmf-dist/tex/latex/breqn/flexisym.sty (/gnu/store/vywyhkvz2nr5037jfz8f10mzcszh5ldh-texlive-flexisym-59745/share/texmf-dist/tex/latex/breqn/cmbase.sym) (/gnu/store/wszi2z0hz9wk21ylfyvzgrfwdd78gkl4-texlive-mathstyle-59745/share/texmf-dist/tex/latex/breqn/mathstyle.sty)) (/gnu/store/igzyhzbvn3nmr6fjn33kdxq6f5mmnlzz-texlive-latex-tools-59745/share/texmf-dist/tex/latex/tools/calc.sty)) (/gnu/store/gh6xyp556my7lxwbmv9aibvvc2844v2f-texlive-microtype-59745/share/texmf-dist/tex/latex/microtype/microtype.sty (/gnu/store/gh6xyp556my7lxwbmv9aibvvc2844v2f-texlive-microtype-59745/share/texmf-dist/tex/latex/microtype/microtype-pdftex.def) (/gnu/store/gh6xyp556my7lxwbmv9aibvvc2844v2f-texlive-microtype-59745/share/texmf-dist/tex/latex/microtype/microtype.cfg))
(/gnu/store/wdq836g7zd1a0vlsgj14nrq22iv0djb3-texlive-makecell-59745/share/texmf-dist/tex/latex/makecell/makecell.sty (/gnu/store/igzyhzbvn3nmr6fjn33kdxq6f5mmnlzz-texlive-latex-tools-59745/share/texmf-dist/tex/latex/tools/array.sty)) (/gnu/store/igzyhzbvn3nmr6fjn33kdxq6f5mmnlzz-texlive-latex-tools-59745/share/texmf-dist/tex/latex/tools/longtable.sty) (/gnu/store/br82d1v2rmx0vqljrqfvnj2mss5gp26c-texlive-tabu-59745/share/texmf-dist/tex/latex/tabu/tabu.sty (/gnu/store/3abywx5j53mvridad7ljz8zl10wjbilr-texlive-latex-varwidth-59745/share/texmf-dist/tex/latex/varwidth/varwidth.sty)) (./realref.sty) (/gnu/store/aiknpz049bqbr73s58yaqk3ln7hq8n4x-texlive-amsfonts-fixed-59745/share/texmf-dist/tex/latex/amsfonts/amssymb.sty (/gnu/store/aiknpz049bqbr73s58yaqk3ln7hq8n4x-texlive-amsfonts-fixed-59745/share/texmf-dist/tex/latex/amsfonts/amsfonts.sty)) (/gnu/store/0jakmwvyf28fcjlvlbp7g4hbvikp7lry-texlive-latex-anysize-59745/share/texmf-dist/tex/latex/anysize/anysize.sty
document style option `anysize' loaded
Michael Salzenberg, Thomas Esser, Dirk Hillbrecht
Version 1.0, Aug 13, 1994
) (./special-settings.sty)
Writing index file metamath.idx
No file metamath.aux.
(/gnu/store/rvpgbbds8lk81yzx6775j6ch2xdwvv52-texlive-hyperref-59745/share/texmf-dist/tex/latex/hyperref/nameref.sty (/gnu/store/198aipzigqav60nyy1970fcfd019xyp1-texlive-latex-refcount-59745/share/texmf-dist/tex/latex/refcount/refcount.sty) (/gnu/store/ah1pabxq8q7p09mnp1djl3bklwl2r5nw-texlive-generic-gettitlestring-59745/share/texmf-dist/tex/generic/gettitlestring/gettitlestring.sty)) (/gnu/store/rs64dc2d1b3zp9xbqxjrbprkhsyzw7i5-texlive-latex-epstopdf-pkg-59745/share/texmf-dist/tex/latex/epstopdf-pkg/epstopdf-base.sty (/gnu/store/7imc8xwaa0xm5bg47barmvjnkgfqyypd-texlive-latexconfig-59745/share/texmf-dist/tex/latex/latexconfig/epstopdf-sys.cfg)) (/gnu/store/gh6xyp556my7lxwbmv9aibvvc2844v2f-texlive-microtype-59745/share/texmf-dist/tex/latex/microtype/mt-cmr.cfg) [1{/gnu/store/alvxjk3cfji845csj2ppr8bkmylj7wvx-texlive-updmap.cfg-59745/share/texmf-dist/fonts/map/pdftex/updmap/pdftex.map}]
(/gnu/store/aiknpz049bqbr73s58yaqk3ln7hq8n4x-texlive-amsfonts-fixed-59745/share/texmf-dist/tex/latex/amsfonts/umsa.fd) (/gnu/store/gh6xyp556my7lxwbmv9aibvvc2844v2f-texlive-microtype-59745/share/texmf-dist/tex/latex/microtype/mt-msa.cfg) (/gnu/store/aiknpz049bqbr73s58yaqk3ln7hq8n4x-texlive-amsfonts-fixed-59745/share/texmf-dist/tex/latex/amsfonts/umsb.fd) (/gnu/store/gh6xyp556my7lxwbmv9aibvvc2844v2f-texlive-microtype-59745/share/texmf-dist/tex/latex/microtype/mt-msb.cfg)
! Math formula deleted: Insufficient extension fonts.
l.861 $\sim$
            \ {\sc Public Domain}\ $\sim$
? 
! Emergency stop.
l.861 $\sim$
            \ {\sc Public Domain}\ $\sim$
!  ==> Fatal error occurred, no output PDF file produced!
Transcript written on metamath.log.
error: in phase 'build-doc': uncaught exception:
%exception #<&invoke-error program: "pdflatex" arguments: ("metamath") exit-status: 1 term-signal: #f stop-signal: #f> 
--8<---------------cut here---------------end--------------->8---

I don’t know what that’s about.

-- 
Ricardo